<?php

namespace objects;

use classes\db;
use classes\object_property;
use Exception;
use traits\db_object_t;

class department_selfserve_conditions_o extends db
{
    use db_object_t;

    public object_property $department; // The department id
    public object_property $lane; // The lane id
    public object_property $product; // The product id
    public object_property $condition_id; // The condition id (optional)
    public object_property $name; // The condition name
    public object_property $description; // The task description
    public object_property $created_at;
    public object_property $updated_at;
    public object_property $deleted_at;


    public function structure(): void
    {
        $this->setTable('department_selfserve_conditions');
    }

    /**
     * Add a condition
     * @param int $department The department id
     * @param int $lane The lane id
     * @param int $product The product id
     * @param string $name The condition name
     * @param string $description The condition description
     * @param int|null $condition_id The condition id (optional)
     * @return department_selfserve_conditions_o
     * @throws Exception If the object was not created successfully
     */
    public function add(int $department, int $lane, int $product, string $name, string $description, int $condition_id = null): department_selfserve_conditions_o
    {
        global /** @var db $db */
        $db;
        // Sanitize the input
        $department = (int)$department;
        $lane = (int)$lane;
        $product = (int)$product;
        $name = $db->escape_string($name);
        $description = $db->escape_string($description);
        if (!is_null($condition_id)) {
            $condition_id = (int)$condition_id;
        }

        // Add the object
        $tmp_id = self::add_object([
            'department' => $department,
            'lane' => $lane,
            'product' => $product,
            'name' => $name,
            'description' => $description,
            ...(!is_null($condition_id) ? ['condition_id' => $condition_id] : []),
        ]);
        $this->id = $tmp_id;
        self::getObjectProperties();
        self::objectChanged();
        return $this;
    }



    public function getObjectProperties(): void
    {
        $this->department = new object_property($this->table, $this->id, 'department', 'int', false);
        $this->lane = new object_property($this->table, $this->id, 'lane', 'int', false);
        $this->product = new object_property($this->table, $this->id, 'product', 'int', false);
        $this->condition_id = new object_property($this->table, $this->id, 'condition_id', 'int', false);
        $this->name = new object_property($this->table, $this->id, 'name', 'string', false);
        $this->description = new object_property($this->table, $this->id, 'description', 'string', false);
        $this->created_at = new object_property($this->table, $this->id, 'created_at', 'timestamp', false);
        $this->updated_at = new object_property($this->table, $this->id, 'updated_at', 'timestamp', false);
        $this->deleted_at = new object_property($this->table, $this->id, 'deleted_at', 'timestamp', false);
    }

    public function objectChanged(): void
    {
        //TODO: Add cache invalidation
    }

    public function asArray(): array
    {
        return [
            'id' => (int)$this->id,
            'department' => (int)$this->department->value(),
            'lane' => (int)$this->lane->value(),
            'product' => (int)$this->product->value(),
            'condition_id' => is_null($this->condition_id->value()) ? null : (int)$this->condition_id->value(),
            'name' => (string)$this->name->value(),
            'description' => (string)$this->description->value(),
            // Timestamps
            'created_at' => (string)$this->created_at->value(),
            'updated_at' => (string)$this->updated_at->value(),
        ];
    }
}